﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Lightstreamer.DotNet.Server;
using System.Net.Sockets;

namespace SimpleDBFeed
{
    public class DataAdapterLauncher
    {
        public static void Main(string[] args)
        {
            string host = "www.mydemos.com";
            int reqrepPort = 6663;
            int notifPort = 6664;
            try
            {
                DataProviderServer server = new DataProviderServer();
                server.Adapter = new TestGreeting();

                TcpClient reqrepSocket = new TcpClient(host, reqrepPort);
                server.RequestStream = reqrepSocket.GetStream();
                server.ReplyStream = reqrepSocket.GetStream();

                TcpClient notifSocket = new TcpClient(host, notifPort);
                server.NotifyStream = notifSocket.GetStream();

                server.Start();
                Console.WriteLine("Remote Adapter connected to Lightstreamer Server.");
                Console.WriteLine("Ready to publish data...");
            }
            catch (Exception ex)
            {
                Console.WriteLine("Could not connect to Lightstreamer Server.");
                Console.WriteLine("Make sure Lightstreamer Server is started before this Adapter.");
                Console.WriteLine(ex);
            }
        }
    }
}
