﻿using System;
using System.Collections;
using System.Linq;
using System.Data.SqlClient;
using Lightstreamer.Interfaces.Data;
using System.Threading;

namespace SimpleDBFeed
{
    public class TestGreeting : IDataProvider
    {
        private IItemEventListener listener;
        private volatile bool go;
        private SqlCommand comm;
        SqlConnection conn;

        //public TestGreeting()
        //{
        //}

        public void Init(IDictionary parameters, string configFile)
        {
            try
            {
                conn = new SqlConnection("Data Source=(local);Initial Catalog=TestDB;Integrated Security=True");
                comm = new SqlCommand("SELECT [Message], [TestTime] FROM GreetingData", conn);
                conn.Open();
            }
            catch (Exception ex)
            {
                Console.WriteLine("Error: " + ex);
                throw new DataProviderException(ex.Message.ToString());
            }
        }

        public void SetListener(IItemEventListener eventListener)
        {
            listener = eventListener;
        }

        public void Subscribe(string itemName)
        {
            if (itemName.Equals("greetings"))
            {
                Thread t = new Thread(new ThreadStart(Run));
                t.Start();
            }
        }

        public void Unsubscribe(string itemName)
        {
            if (itemName.Equals("greetings"))
            {
                go = false;
            }
        }

        public bool IsSnapshotAvailable(string itemName)
        {
            return false;
        }

        public void Run()
        {
            go = true;
            try
            {
                while (go)
                {
                    SqlDataReader dr = comm.ExecuteReader();
                    while (dr.Read())
                    {
                        IDictionary eventData = new Hashtable();
                        eventData.Add("Message", dr[0]);
                        eventData.Add("TestTime", dr[1]);

                        listener.Update("greetings", eventData, false);
                    }
                }
            }
            catch (Exception ex) { Console.WriteLine(ex); }
            finally { conn.Close(); }
        }
    }
}
